=== Code/BasicFilters/CMakeLists.txt ===


# Set up code generation
include(sitkGenerateFilterSource)
generate_filter_source()

add_subdirectory( src )
