=== Code/Explicit/CMakeLists.txt ===

add_subdirectory( src )
