=== debian/changelog ===
simpleitk (1.0.1-2) unstable; urgency=medium

  * Cherry-pick upstream fix for FTBFS on i386.
    Thanks to Adrian Bunk for reporting (Closes: #892459)
  * Point the VCS URIs to salsa.debian.org
  * Bump the debhelper version to 11
  * Bump the standards version to 4.1.3
  * Include the NOTICE file in binary packages

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 13 Mar 2018 09:08:40 +0000

simpleitk (1.0.1-1) unstable; urgency=low

  * Initial release. (Closes: #740296)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 02 Nov 2017 08:49:18 +0000
