=== debian/control ===
Source: simpleitk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 11),
               dh-python,
               dpkg-dev (>= 1.17.14),
               googletest <!nocheck>,
               libfftw3-dev,
               libinsighttoolkit4-dev (>= 4.11),
               lua5.1,
               python3-dev,
               python3-numpy,
               python3-setuptools,
               swig (>= 3.0.12)
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/med-team/simpleitk
Vcs-Git: https://salsa.debian.org/med-team/simpleitk.git
Homepage: http://www.simpleitk.org/

Package: libsimpleitk1.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: cross-platform image analysis toolkit
 SimpleITK is an image analysis toolkit with a large number of components
 supporting general filtering operations, image segmentation and registration.
 It is built on top of the Insight Segmentation and Registration Toolkit ITK
 with the intent of providing a simplified interface to ITK. SimpleITK itself is
 written in C++ but is available for a large number of programming languages.
 .
 This package provides the shared libraries.

Package: libsimpleitk1-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsimpleitk1.0 (= ${binary:Version})
Description: development files for SimpleITK
 SimpleITK is an image analysis toolkit with a large number of components
 supporting general filtering operations, image segmentation and registration.
 It is built on top of the Insight Segmentation and Registration Toolkit ITK
 with the intent of providing a simplified interface to ITK. SimpleITK itself is
 written in C++ but is available for a large number of programming languages.
 .
 This package provides the development files.

Package: python3-simpleitk
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python bindings for SimpleITK
 SimpleITK is an image analysis toolkit with a large number of components
 supporting general filtering operations, image segmentation and registration.
 It is built on top of the Insight Segmentation and Registration Toolkit ITK
 with the intent of providing a simplified interface to ITK. SimpleITK itself is
 written in C++ but is available for a large number of programming languages.
 .
 This package provides the Python bindings.
