=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDDIR=$(CURDIR)/SimpleITK-build
DESTDIR=$(CURDIR)/debian/tmp

BUILD_OPTIONS=-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DExternalData_OBJECT_STORES:PATH=$(CURDIR)/data/.ExternalData \
	-DSimpleITK_4D_IMAGES:BOOL=ON \
	-DSimpleITK_BUILD_DISTRIBUTE:BOOL=ON \
	-DSimpleITK_EXPLICIT_INSTANTIATION:BOOL=OFF \
	-DSimpleITK_FORBID_DOWNLOADS:BOOL=ON \
	-DSimpleITK_INSTALL_ARCHIVE_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
	-DSimpleITK_INSTALL_LIBRARY_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
	-DWRAP_DEFAULT:BOOL=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS+=-DBUILD_TESTING:BOOL=ON \
	-DGTEST_ROOT:PATH=/usr/src/googletest
else
BUILD_OPTIONS+=-DBUILD_TESTING:BOOL=OFF
endif

PYTHON3:=$(shell py3versions -d)

BUILD_OPTIONS+=-DWRAP_PYTHON:BOOL=ON \
	-DSimpleITK_PYTHON_USE_VIRTUALENV:BOOL=OFF \
	-DSimpleITK_PYTHON_WHEEL:BOOL=OFF \
	-DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(PYTHON3)

%:
	dh $@ --with python3 --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$(BUILDDIR)/lib dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR)/Wrapping/Python/Packaging \
		&& $(PYTHON3) setup.py install --root $(DESTDIR) --install-layout=deb

override_dh_installdocs:
	dh_installdocs NOTICE
