=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/
    https://github.com/SimpleITK/SimpleITK/releases \
    .*/SimpleITK@ANY_VERSION@@ARCHIVE_EXT@ debian
opts=component=data,uversionmangle=s/(rc|a|b|c)/~$1/ \
    https://github.com/SimpleITK/SimpleITK/releases \
    .*/SimpleITKData@ANY_VERSION@@ARCHIVE_EXT@ same
